# coding: utf-8

"""
    Pieces Isomorphic OpenAPI

    Endpoints for Assets, Formats, Users, Asset, Format, User.

    The version of the OpenAPI document: 1.0
    Contact: tsavo@pieces.app
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, Field
from typing import Any, ClassVar, Dict, List, Optional
from pieces_os_client.models.embedded_model_schema import EmbeddedModelSchema
from pieces_os_client.models.graphical_image_processing import GraphicalImageProcessing
from pieces_os_client.models.graphical_ocr_processing import GraphicalOCRProcessing
from pieces_os_client.models.graphical_svg_statistics import GraphicalSVGStatistics
from typing import Optional, Set
from typing_extensions import Self

class GraphicalMachineLearningProcessingEvent(BaseModel):
    """
    GraphicalMachineLearningProcessingEvent
    """ # noqa: E501
    var_schema: Optional[EmbeddedModelSchema] = Field(default=None, alias="schema")
    ocr: Optional[GraphicalOCRProcessing] = None
    image: Optional[GraphicalImageProcessing] = None
    svg: Optional[GraphicalSVGStatistics] = None
    __properties: ClassVar[List[str]] = ["schema", "ocr", "image", "svg"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GraphicalMachineLearningProcessingEvent from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of var_schema
        if self.var_schema:
            _dict['schema'] = self.var_schema.to_dict()
        # override the default output from pydantic by calling `to_dict()` of ocr
        if self.ocr:
            _dict['ocr'] = self.ocr.to_dict()
        # override the default output from pydantic by calling `to_dict()` of image
        if self.image:
            _dict['image'] = self.image.to_dict()
        # override the default output from pydantic by calling `to_dict()` of svg
        if self.svg:
            _dict['svg'] = self.svg.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GraphicalMachineLearningProcessingEvent from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "schema": EmbeddedModelSchema.from_dict(obj["schema"]) if obj.get("schema") is not None else None,
            "ocr": GraphicalOCRProcessing.from_dict(obj["ocr"]) if obj.get("ocr") is not None else None,
            "image": GraphicalImageProcessing.from_dict(obj["image"]) if obj.get("image") is not None else None,
            "svg": GraphicalSVGStatistics.from_dict(obj["svg"]) if obj.get("svg") is not None else None
        })
        return _obj


