# coding: utf-8

"""
    Pieces Isomorphic OpenAPI

    Endpoints for Assets, Formats, Users, Asset, Format, User.

    The version of the OpenAPI document: 1.0
    Contact: tsavo@pieces.app
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from pieces_os_client.models.embedded_model_schema import EmbeddedModelSchema
from pieces_os_client.models.externally_sourced_enum import ExternallySourcedEnum
from pieces_os_client.models.mailgun_metadata import MailgunMetadata
from typing import Optional, Set
from typing_extensions import Self

class PersonBasicType(BaseModel):
    """
    This is all optional properties around the most basic information around a non-pieces user.  A Basic type will NOT have a scope as it is not an actual pieces user.
    """ # noqa: E501
    var_schema: Optional[EmbeddedModelSchema] = Field(default=None, alias="schema")
    username: Optional[StrictStr] = Field(default=None, description="username or twitter handle...etc")
    name: Optional[StrictStr] = Field(default=None, description="This is the name of the basic user.")
    picture: Optional[StrictStr] = Field(default=None, description="this is a url picture representation of a user.")
    email: Optional[StrictStr] = Field(default=None, description="an email that was extracted.")
    sourced: Optional[ExternallySourcedEnum] = None
    url: Optional[StrictStr] = Field(default=None, description="This is a specific url that this basic user came from.")
    mailgun: Optional[MailgunMetadata] = None
    __properties: ClassVar[List[str]] = ["schema", "username", "name", "picture", "email", "sourced", "url", "mailgun"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PersonBasicType from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of var_schema
        if self.var_schema:
            _dict['schema'] = self.var_schema.to_dict()
        # override the default output from pydantic by calling `to_dict()` of mailgun
        if self.mailgun:
            _dict['mailgun'] = self.mailgun.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PersonBasicType from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "schema": EmbeddedModelSchema.from_dict(obj["schema"]) if obj.get("schema") is not None else None,
            "username": obj.get("username"),
            "name": obj.get("name"),
            "picture": obj.get("picture"),
            "email": obj.get("email"),
            "sourced": obj.get("sourced"),
            "url": obj.get("url"),
            "mailgun": MailgunMetadata.from_dict(obj["mailgun"]) if obj.get("mailgun") is not None else None
        })
        return _obj


